/* similar to plots3d */
#include <stdio.h>
#include "LIB/message.h"
#include "LIB/constmap.h"
#include "LIB/dimension.h"
#include "LIB/menu.h"

float  *farray1();
float Legpolyn();
void free_farray1();
FILE *getfp();

void grids3d()
{
char disc[4][6],string[40],ifset;
float *coef;
FILE *fp;
int maxs,kmaxw,kmaxu,kmaxl,ndis,kmax,jump,hmax,mdim,vjump,i,p;
float mindep,maxdep,fac,x,r,*mdl;

  fp=getfp("r");
  fscanf(fp,"%d %d %d %d %d",&maxs,&kmaxw,&kmaxu,&kmaxl,&ndis);
  if(maxs>MAXS) STOP(grids3d: maxs too large);
  
  if(kmaxw>=0 || (kmaxu>=0 && kmaxl>=0) )
  { mindep=RADIUS-RMOHO;
    maxdep=RADIUS-RCMB;
  }
  else if(kmaxu>=0)
  { mindep=RADIUS-RMOHO;
    maxdep=RADIUS-R670;
  }
  else if(kmaxl>=0)
  { mindep=RADIUS-R670;
    maxdep=RADIUS-RCMB;
  }
  else 
  { mindep=0.0;
    maxdep=0.0;
  }
  printf(" Depth range: [%4d %4d] km", (int)mindep,(int)maxdep);
  
  disc[0][0]=disc[1][0]=disc[2][0]=disc[3][0]='\0'; 
  if(ndis)
  { printf(";  Discontinuities:");
    for(i=0;i<ndis;i++)
    { fscanf(fp,"%s",disc[i]);
      printf(" %s",disc[i]);
    }
  }
  printf("\n");
  
  hmax=(maxs+1)*(maxs+1);
  mdim=hmax*(ndis+kmaxw+1+kmaxu+1+kmaxl+1);
  mdl=farray1(0,mdim-1);
  for(i=0;i<mdim;i++) fscanf(fp,"%g",&mdl[i]);
  fclose(fp);
  
  vjump=hmax*(kmaxw+1+kmaxu+1+kmaxl+1);
  
  coef=farray1(0,hmax-1);
  
  ifset='y';
  
    printf(" Specify a depth,");
    if(ndis)
    { printf(" or ");
      for(i=0;i<ndis;i++) printf("'%c' ",disc[i][0]);
      printf(" for discontinuity,");
    }
    getrecord(string);
    
    if(string[0]=='s') for(i=0;i<hmax;i++) coef[i]=mdl[vjump+i]*6368.0;
    else if(string[0]=='m')
    { if(disc[0][0]=='m') jump=0;
      else if(disc[1][0]=='m') jump=hmax;
      else STOP(grids3d: error in getting moho);
      for(i=0;i<hmax;i++) coef[i]=mdl[vjump+jump+i]*RMOHO;
    }
    else if(string[0]=='d')
    { if(disc[0][0]=='d') jump=0;
      else if(disc[1][0]=='d') jump=hmax;
      else if(disc[2][0]=='d') jump=2*hmax;
      else STOP(grids3d: error in getting d670);
      for(i=0;i<hmax;i++) coef[i]=mdl[vjump+jump+i]*R670;
    }
    else if(string[0]=='c')
      for(i=0;i<hmax;i++) coef[i]=mdl[vjump+hmax*(ndis-1)+i]*RCMB;
    else if(string[0]>='1' && string[0]<='9')
    { sscanf(string,"%f",&r);
      r=RADIUS-r;
      
      if(kmaxw<0)
      { if(r>R670)
        { if(kmaxu<0) STOP(grids3d: upper mantle not availabel);
	  x=-1.+2.*(r-R670)/(RMOHO-R670);
	  kmax=kmaxu;
	  jump=0;
        }
        else
        { if(kmaxl<0) STOP(grids3d: lower mantle not availabel);
	  x=-1.+2.*(r-RCMB)/(R670-RCMB);
	  kmax=kmaxl;
	  jump=(kmaxu+1)*hmax;
        }
      }
      else
      { if(kmaxu>=0 || kmaxl>=0) STOP(grids3d: error in s3d file);
	x=-1.+2.*(r-RCMB)/(RMOHO-RCMB);
	kmax=kmaxw;
	jump=0;
      }
      
      for(i=0;i<hmax;i++) coef[i]=0;
      for(p=0;p<=kmax;p++)
      { fac=100.*Legpolyn(p,x);
        for(i=0;i<hmax;i++) coef[i]+=fac*mdl[jump+i+p*hmax];
      }
    }
   
    harmogrid(maxs,coef,"X^",ifset);
    ifset='n';
 
  free_farray1(mdl,0);
  free_farray1(coef,0);
 
}
